---
title: Security changes in Firefox 3.5
slug: Mozilla/Firefox/Releases/3.5/Security_changes
tags:
  - Firefox
  - Firefox 3.5
  - Security
  - XUL
---
<div>{{FirefoxSidebar}}</div><p>{{ fx_minversion_header(3.5) }}</p>
<p>{{ draft() }}</p>
<p>This article covers security-related changes in Firefox 3.5.</p>
<h2 id="Changes_to_chrome_registration">Changes to chrome registration</h2>
<p>A security hole was closed in order to prevent remote content to be used as chrome.  This could impact any add-on that included a resource in their <code>chrome.manifest</code> file that referenced a file on the web.</p>
<p>Fixing this bug was accomplished by adding a new <code>URI_IS_LOCAL_RESOURCE</code> flag to the {{ interface("nsIProtocolHandler") }} interface that indicates that the protocol is safe to register as chrome.  Any add-on that creates its own protocol handler and tries to register it in its <code>chrome.manifest</code> file will have to use this flag in order to work correctly.</p>
<h2 id="Private_browsing">Private browsing</h2>
<p>Firefox 3.5 implements private browsing, a mode in which cookies, history, and other potentially private information isn't saved permanently on the user's computer.  Extensions and other add-ons may support the private browsing feature, detecting when it's in use so they can avoid saving private information while private browsing mode is enabled.  See <a class="internal" href="/En/Supporting_private_browsing_mode" title="En/Supporting private browsing mode">Supporting private browsing mode</a> for details.</p>
<p>Plug-ins can detect whether or not private browsing mode is in effect by using the <a class="internal" href="/en/NPN_GetValue" title="En/NPN GetValue"><code>NPN_GetValue()</code></a> function to check the current value of the <code>NPNVprivateModeBool</code> variable.</p>
<h2 id="New_certificate_error_handling">New certificate error handling</h2>
<p>In previous versions of Firefox 3, SSL certificate errors resulted in the presentation of the standard network error page, <code>about:neterror</code>, in the browser window.  Starting in Firefox 3.5, there is a new error page, <code>about:certerror</code>, which is displayed instead.  The error URL is formatted like this:</p>
<p><code>about:certerror?e=error&amp;u=url&amp;d=desc</code></p>
<p>Embedders needing to provide custom certificate error pages can now do so by supplying their own <code>about:</code> page  implementation, and setting the <code>security.alternate_certificate_error_page</code> preference to the appropriate page name (e.g. <code>"certerror</code>").</p>
<h2 id="See_also">See also</h2>
<ul> <li><a class="internal" href="/En/Firefox%203.5%20for%20developers" title="En/Firefox 3.5 for developers">Firefox 3.5 for developers</a> </li>
</ul>
